/* ***************************** */
/*       .. 11/96   */
/* ***************************** */
/*            GAME.C             */
/*      因      */
/* ***************************** */
#include <conio.h>
#include <stdio.h>
#define LEFT   5
#define TOP    2
#define RIGHT  75
#define BOTTOM 24
#define ROWS    10
#define COLUMNS 10
char genia [ROWS] [COLUMNS];
FILE *genies;

main(argc,argv)
int argc;
char *argv[];
{
   void start();
   void genia1();
   void generation();
   char ch;
   int counter=0;

   start();
   genia1(argv);
   ch='n';
   while (ch == 'n')
   {
      gotoxy(30,21);
      cprintf("%2d I",++counter);
      gotoxy(16,22);
      cprintf("㩫 N(next)   棜 ");
      gotoxy(25,23);
      cprintf(" Q(quit)  ⢦");
      ch='k';
      while (ch!='n' && ch !='q')
	   ch=getch();
      generation();
   }
}

void start()
{
   textbackground( BLACK );
   clrscr();
   window(LEFT,TOP,RIGHT,BOTTOM);
   highvideo();
   textbackground( BLUE );
   clrscr();
   gotoxy (24,13);
   textcolor( BLINK+WHITE );
   cprintf("   ");
   textcolor( WHITE );
   gotoxy(71,23);
   getch();
}

void genia1(gargv)
char *gargv[];
{
   int i,j;
   int k,n=0;
   int cnt1=0;

   genies = fopen(gargv[1],"r");
   if (genies == NULL)
      {
	 clrscr();
	 gotoxy(18,13);
	 cprintf(" TXT     ");
	 getch();
	 exit();
      }
   for (i=0; i<ROWS; i++)
      for (j=0; j<COLUMNS; j++)
	 genia[i][j]=getc(genies);
   fclose(genies);
   for (i=0; i<ROWS; i++)
      for (j=0; j<COLUMNS; j++)
	 if (genia[i][j] == 'o')
	    cnt1++;
   if (cnt1 == (ROWS*COLUMNS))
       {
	  clrscr();
	  gotoxy(17,13);
	  cprintf("H       ");
	  getch();
	  exit();
       }
   for (i=0; i<ROWS; i++)
      {
	 k=i+1;
	 gotoxy(9,k+(n++));
	 for (j=0; j<COLUMNS; j++)
	    cprintf("%-6c",genia[i][j]);
      }
}

void generation()
{
   char geniaX [ROWS] [COLUMNS];
   int count();
   int i,j;
   int k,n=0;
   int cnt=0,cnt1=0,cnt2=0;

   for (i=0; i<ROWS; i++)
      for (j=0; j<COLUMNS; j++)
	{
	   cnt=count(i,j);
	   switch (cnt)
	   {
	      case 0 :
	      case 1 :
	      case 7 :
	      case 8 :
		geniaX[i][j]='o';
		break;
	      case 2 :
	      case 3 :
	      case 4 :
		 geniaX[i][j]=genia[i][j];
		 break;
	      case 5 :
	      case 6 :
		 geniaX[i][j]='x';
		 break;
	      default:
		 geniaX[i][j]='r';
	   }
	}
   for (i=0; i<ROWS; i++)
      for (j=0; j<COLUMNS; j++)
	 if ( genia[i][j]==geniaX[i][j] )
	    cnt1++;
   if ( cnt1== ROWS*COLUMNS )
       {
	  clrscr();
	  for (i=0; i<ROWS; i++)
	  {
	     k=i+1;
	     gotoxy(9,k+(n++));
	     for (j=0; j<COLUMNS; j++)
		cprintf("%-6c",genia[i][j]);
	  }
	  gotoxy(20,22);
	  cprintf("H     ");
	  gotoxy(22,23);
	  cprintf("      ");
	  getch();
	  exit();
       }
   for (i=0; i<ROWS; i++)
      for (j=0; j<COLUMNS; j++)
	 genia[i][j]=geniaX[i][j];
   for (i=0; i<ROWS; i++)
      {
	 k=i+1;
	 gotoxy(9,k+(n++));
	 for (j=0; j<COLUMNS; j++)
	    cprintf("%-6c",genia[i][j]);
      }
   for (i=0; i<ROWS; i++)
      for (j=0; j<COLUMNS; j++)
	 if (genia[i][j] == 'o')
	    cnt2++;
   if (cnt2 == (ROWS*COLUMNS))
       {
	  clrscr();
	  gotoxy(26,13);
	  cprintf("H  ");
	  getch();
	  exit();
       }
}

int count(x,y)
int x,y;
{
   int changeR();
   int changeC();
   int cnt=0;
   int xx,yy;

   xx=changeR(x-1);
   yy=changeC(y-1);
   if (genia [xx] [yy] == 'x') cnt++;
   xx=changeR(x-1);
   yy=y;
   if (genia [xx] [yy] == 'x') cnt++;
   xx=changeR(x-1);
   yy=changeC(y+1);
   if (genia [xx] [yy] == 'x') cnt++;
   xx=x;
   yy=changeC(y-1);
   if (genia [xx] [yy] == 'x') cnt++;
   xx=x;
   yy=changeC(y+1);
   if (genia [xx] [yy] == 'x') cnt++;
   xx=changeR(x+1);
   yy=changeC(y-1);
   if (genia [xx] [yy] == 'x') cnt++;
   xx=changeR(x+1);
   yy=y;
   if (genia [xx] [yy] == 'x') cnt++;
   xx=changeR(x+1);
   yy=changeC(y+1);
   if (genia [xx] [yy] == 'x') cnt++;
   return(cnt);
}

int changeR(z)
int z;
{
   int zz;

   if ( z>=0 && z<ROWS )
      zz=z;
   else
   if ( z<0 )
      zz=ROWS-1;
   else zz=0;
   return(zz);
}

int changeC(z)
int z;
{
   int zz;

   if ( z>=0 && z<COLUMNS )
      zz=z;
   else
   if ( z<0 )
      zz=COLUMNS-1;
   else zz=0;
   return(zz);
}
